From 7c6bcab2990bc15c0a0a0c2da899ed334983ec74 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 10 2017 18:12:49 +0000
Subject: [PATCH 791/1001] Implement the config panel backend


---

diff --git a/hubs/default_config.py b/hubs/default_config.py
index 1c50405..688e51c 100644
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -33,6 +33,16 @@ OIDC_SCOPES = [
 #        the right tag to link people to.  AGPL ftw.
 SOURCE_URL = 'https://pagure.io/fedora-hubs/blob/develop/f'  # /hubs/widgets/badges.py'
 
+CHAT_NETWORKS = [
+    {
+        "name": "Freenode",
+        "domain": "irc.freenode.net",
+    }, {
+        "name": "Matrix",
+        "domain": "matrix.org",
+    }
+]
+
 
 WIDGETS = [
     'hubs.widgets.about:About',
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 128d50a..30d4fb9 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -148,16 +148,22 @@ def hub_config(name):
     config = {
         "status": "OK",
         "result": {
-            "hub": hub.name,
+            "hub": {},
+            "general": {
+                "chat_networks": app.config["CHAT_NETWORKS"],
             },
-        }
+        },
+    }
     if flask.request.method == 'POST':
         for key, value in flask.request.form.items():
-            hub.config[key] = value
+            setattr(hub.config, key, value)
+        if (not flask.request.form["chat_domain"]
+            and len(app.config["CHAT_NETWORKS"]) > 0):
+            hub.config.chat_domain = app.config["CHAT_NETWORKS"][0]["domain"]
         try:
             flask.g.db.commit()
         except Exception as err:
             config = {"status": "ERROR", "message": str(err)}
             return flask.jsonify(config), 400
-    config["result"].update(hub.config.__json__())
+    config["result"]["hub"].update(hub.config.__json__())
     return flask.jsonify(config)

